/* service.vala
 *
 * Copyright (C) 2008 Johann Prieur <johann.prieur@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 */


namespace People {

	internal static const string BUS_NAME = "net.launchpad.People";
	internal static const string OBJECT_PATH = "net/launchpad/People";

	public class Service : DBusObject {
		public Service (DBus.Connection? connection = null) {
			if (connection == null)
				this.connection = DBus.Bus.get (DBus.BusType.SESSION);
			else
				this.connection = connection;

			this.object = this.connection.get_object (BUS_NAME, OBJECT_PATH);
		}

		public AddressBook request_address_book (string address_book_id) {
			string bus_name, object_path;

			try {
				this.object.RequestAddressBook (address_book_id, out bus_name, out object_path);
			} catch (DBus.Error e) {
				warning (e.message);
			}

			return new AddressBook (connection, bus_name, object_path);
		}
	}

}
